// ------------------------------------------------------------------------------------------------
// This file is part of InformationLib.
//
// InformationLib is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// InformationLib is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with InformationLib.  If not, see <http://www.gnu.org/licenses/>.
// ------------------------------------------------------------------------------------------------
using InformationLib.DataAccess;
using System;                                     // for 
using System.Data;                                // for many(8)
using System.Data.Common;                         // for many(7), DbDataAdapter

namespace InformationLib.DataAccess
{
    // --------------------------------------------------------------------------------------------
    /// <!-- DataReaderAdapter -->
    /// <summary>
    /// 
    /// </summary>
    public class DataReaderAdapter : DbDataAdapter
    {
        // ----------------------------------------------------------------------------------------
        /// <!-- FillFromReader -->
        /// <summary>
        /// 
        /// </summary>
        /// <param name="dataTable"></param>
        /// <param name="dataReader"></param>
        /// <returns></returns>
        public int FillFromReader(DataTable dataTable, IDataReader dataReader)
        {
            if (dataReader == null)
                Throws.A(new NoNullAllowedException("FillFromReader error - dataReader is null"));
            return this.Fill(dataTable, dataReader);
        }


        protected override RowUpdatedEventArgs CreateRowUpdatedEvent(DataRow dataRow, IDbCommand command, StatementType statementType, DataTableMapping tableMapping){ return null; }
        protected override RowUpdatingEventArgs CreateRowUpdatingEvent(DataRow dataRow, IDbCommand command, StatementType statementType, DataTableMapping tableMapping) { return null; }
        protected override void OnRowUpdated(RowUpdatedEventArgs value) { }
        protected override void OnRowUpdating(RowUpdatingEventArgs value) { }

    }
}
