﻿// ------------------------------------------------------------------------------------------------
// This file is part of InformationLib.
//
// InformationLib is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// InformationLib is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with InformationLib.  If not, see <http://www.gnu.org/licenses/>.
// ------------------------------------------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace InformationLib.Endemes
{
    /// <summary>
    /// 
    /// </summary>
    public class EndemeQuantification
    {
        public Dictionary<char, double> Raw   { get; set; } // you can dump raw values into here and use them to build the endeme later
        public Dictionary<char, double> Calc  { get; set; } // you can build values here from the endeme


        // ----------------------------------------------------------------------------------------
        //  Constructor
        // ----------------------------------------------------------------------------------------
        public EndemeQuantification()
        {
            Raw = new Dictionary<char, double>(26);
            for (char c = 'A'; c <= 'Z'; ++c) Raw.Add(c, 0);
            Calc = new Dictionary<char, double>(26);
            for (char c = 'A'; c <= 'Z'; ++c) Calc.Add(c, 0);
        }


        public IEnumerable<char> RawKeys  { get { return Raw.Keys;  } }
        public IEnumerable<char> CalcKeys { get { return Calc.Keys; } }

    }
}
