// ------------------------------------------------------------------------------------------------
// This file is part of InformationLib.
//
// InformationLib is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// InformationLib is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with InformationLib.  If not, see <http://www.gnu.org/licenses/>.
// ------------------------------------------------------------------------------------------------
using System;                                     // for Math

namespace InformationLib.Strings // THIS NAMESPACE IS A PRIMITIVE!  use only System.* references
{
    // --------------------------------------------------------------------------------------------
    /// <!-- StringCommon -->
    /// <summary>
    ///      The StringCommon class finds the longest common string between two strings, and its
    ///      positions etc
    /// </summary>
    /// <remarks>
    ///      A very inefficient diff
    ///      Needs testing
    /// </remarks>
    public class StringCommon_old
    {
        public StringPair Str  { get { return _str;  } } private StringPair _str;
        public StringPair Sub1 { get { return _sub1; } } private StringPair _sub1;
        public StringPair Sub2 { get { return _sub2; } } private StringPair _sub2;
        public StringPair Sub3 { get { return _sub3; } } private StringPair _sub3;


        // ----------------------------------------------------------------------------------------
        /// <!-- CommonStr constructors -->
        // ----------------------------------------------------------------------------------------
        public StringCommon_old(StringPair pair, bool compareAutomatically)
        { _str = pair;                        if (compareAutomatically)  Compare(); }
        public StringCommon_old(string strA, string strB, bool compareAutomatically)
        { _str = new StringPair(strA, strB);  if (compareAutomatically)  Compare(); }


        // ----------------------------------------------------------------------------------------
        /// <!-- Compare -->
        /// <summary>
        ///      Compares the two strings in Str, returing the longest match in Sub2 and the
        ///      remainder before in Sub1 and the remainder after in Sub3
        ///      It often makes sense to do this automatically when the constructor is run
        /// </summary>
        public void Compare()
        {
            _str.FindLongestMatch();
            _sub1 = _str.Before;
            _sub2 = _str.Match;
            _sub3 = _str.After;
        }


        // ----------------------------------------------------------------------------------------
        /// <!-- FirstDiff -->
        /// <summary>
        /// 
        /// </summary>
        /// <param name="strA"></param>
        /// <param name="strB"></param>
        /// <returns></returns>
        public static string FirstDiff(string strA, string strB)
        {
            string toFirst = "";
            char[] charA = strA.ToCharArray();
            char[] charB = strB.ToCharArray();
            for (int i = 0; charA[i] == charB[i] && i < Math.Min(charA.Length, charB.Length); ++i)
            { toFirst += charA[i]; }
            return toFirst;
        }


    }
}
